#define UNICODE
#define _UNICODE

#include <windows.h>
#include "myxfrp.h"

HANDLE hEvent = NULL;

#pragma data_seg(".shared")
MYXFR_SHARED_DATA shrMem = { 0,0,0,0,0,0 };
#pragma data_seg() 

//-----------------------------------------------------------------
BOOL __stdcall DllMain(HANDLE DLLHandle, DWORD Reason, LPVOID Rsrv)
{
    switch (Reason) {
        case DLL_PROCESS_ATTACH:
            if (hEvent = NULL) {
                hEvent = CreateEvent(NULL,FALSE,TRUE,
                                     MYXFR_SYNC_NAME);
            }
            break;

        case DLL_PROCESS_DETACH:
            break;

        case DLL_THREAD_ATTACH:
        case DLL_THREAD_DETACH:
            break;
    }
    return TRUE;

} // DllMain

// ------------ Entrypoints for DLLs primary function -------------

BOOL MyReadData(LPBYTE Buffer, ULONG BufferSize)
{
    if (Buffer == NULL || BufferSize == 0) {
        return FALSE;
    }

    // process the read...

    memset(Buffer, 0xaa, BufferSize);

    WaitForSingleObject(hEvent, INFINITE);
    shrMem.BytesRead += BufferSize;
    shrMem.ReadCalls++;
    SetEvent(hEvent);

    return TRUE;

} // MyReadData

//-----------------------------------------------------------------
BOOL MyWriteData(LPBYTE Buffer, ULONG BufferSize) 
{
    // process the write...

    WaitForSingleObject(hEvent, 5000);
    shrMem.BytesWritten += BufferSize;
    shrMem.WriteCalls++;
    SetEvent(hEvent);

    return TRUE;

} // MyWriteData
