// myxfrp.h

#define MYXFR_INSTANCES         1
#define MYXFR_COUNTERS          6
#define GLOBAL_STR              TEXT("Global")
#define COSTLY_STR              TEXT("Costly")
#define FOREIGN_STR             TEXT("Foreign")

#define MYXFR_SYNC_NAME         TEXT("MyXfrSyncEvent")
#define MYXFR_SHARED_DATA_NAME  TEXT("MyXfrSharedData")
#define MYXFR_INSTANCE_NAME TEXT("0")
#define MYXFR_REGKEY \
    TEXT("SYSTEM\\CurrentControlSet\\Services\\MyXfr\\Performance")

#define DWORD_MULTIPLE(x)       \
            (((x+sizeof(DWORD)-1)/sizeof(DWORD))*sizeof(DWORD))

#pragma pack (8)

typedef struct _MYXFR_SHARED_DATA {
    DWORD   BytesRead;
    DWORD   BytesWritten;
    DWORD   BytesTotal;
    DWORD   ReadCalls;
    DWORD   WriteCalls;
    DWORD   TotalCalls;
} MYXFR_SHARED_DATA, *PMYXFR_SHARED_DATA;

typedef struct _MYXFR_DATA_DEFINITION {
    PERF_OBJECT_TYPE          MyXfrObjectType;
    PERF_COUNTER_DEFINITION   BytesReadDef;
    PERF_COUNTER_DEFINITION   BytesWrittenDef;
    PERF_COUNTER_DEFINITION   BytesTotalDef;
    PERF_COUNTER_DEFINITION   ReadCallsDef;
    PERF_COUNTER_DEFINITION   WriteCallsDef;
    PERF_COUNTER_DEFINITION   TotalCallsDef;
} MYXFR_DATA_DEFINITION, *PMYXFR_DATA_DEFINITION;

typedef struct _MYXFR_COUNTER {
    PERF_COUNTER_BLOCK        CounterBlock;
    DWORD                     BytesRead;
    DWORD                     BytesWritten;
    DWORD                     BytesTotal;
    DWORD                     ReadCalls;
    DWORD                     WriteCalls;
    DWORD                     TotalCalls;
} MYXFR_COUNTER, *PMYXFR_COUNTER;

#pragma pack ()
