#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"
#include "combobug.h"

static void setTitles( HWND hwnd ) {
    static int nDlgNo = 0;
    if ( 1 == ++nDlgNo ) {
        SetWindowText( hwnd, _T( "Misbehaved Combo" ) );
        SetDlgItemText( hwnd, IDCANCEL, _T( "Next" ) );
    } else {
        SetWindowText( hwnd, _T( "Well Behaved Combo" ) );
    }
}

static void initCombo( HWND hwndCombo ) {
    ComboBox_AddString( hwndCombo, _T( "one"   ) );
    ComboBox_AddString( hwndCombo, _T( "two"   ) );
    ComboBox_AddString( hwndCombo, _T( "three" ) );
    ComboBox_AddString( hwndCombo, _T( "four"  ) );
    ComboBox_AddString( hwndCombo, _T( "five"  ) );
}

#if defined( _MSC_VER ) && 800 <= _MSC_VER
#pragma warning( disable: 4100 ) // unreferenced formal parameter
#endif

static BOOL CALLBACK 
dlgTest( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam ) {

    const int id         = GET_WM_COMMAND_ID ( wParam, lParam );
    const int codeNotify = GET_WM_COMMAND_CMD( wParam, lParam );

    HWND hwndCombo = GetDlgItem( hwnd, IDC_COMBO );

    switch ( msg ) {
    case WM_INITDIALOG:
        setTitles( hwnd );
        initCombo( hwndCombo );
        SetTimer( hwnd, 1, /* ms = */ 100, 0 );
        return TRUE;

    case WM_TIMER:
        SetDlgItemInt( hwnd, IDC_CURSEL, 
            ComboBox_GetCurSel( hwndCombo ), TRUE );
        break;

    case WM_COMMAND:
        if ( IDCANCEL == id && BN_CLICKED == codeNotify ) {
    case WM_CLOSE:
            KillTimer( hwnd, 1 );
            EndDialog( hwnd, IDCANCEL );
        }
        return TRUE;
    }
    return FALSE;
}

int APIENTRY 
WinMain( HINSTANCE hinst, HINSTANCE hPrev, LPSTR psz, int nShow ) {

    DialogBox( hinst, _T( "TestDlg" ), HWND_DESKTOP, dlgTest );
    fixComboBug(); //*** This is it!
    DialogBox( hinst, _T( "TestDlg" ), HWND_DESKTOP, dlgTest );
    return 0;
}
